package jp.wasabeef.picasso.transformations.gpu;

/**
 * Copyright (C) 2015 Wasabeef
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

import android.content.Context;
import android.graphics.PointF;
import jp.co.cyberagent.android.gpuimage.GPUImageBoxBlurFilter;

/**
 * 
 * 
 * 
 */
public class BoxBlurFilterTransformation extends GPUFilterTransformation {

	private float mBlurSize = 1f;

  public BoxBlurFilterTransformation(Context context) {
    this(context, 1f);
  }

  public BoxBlurFilterTransformation(Context context, float BlurSize) {
    super(context, new GPUImageBoxBlurFilter());
    mBlurSize = BlurSize;
    GPUImageBoxBlurFilter filter = getFilter();
    filter.setBlurSize(mBlurSize);
  }

  @Override public String key() {
    return "BoxBlurFilterTransformation(mBlurSize = " + mBlurSize + ")";
    //    ",lineWidth = " + mLineWidth + ")";
  }
}
