package jp.wasabeef.picasso.transformations.gpu;

/**
 * Copyright (C) 2015 Wasabeef
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

import android.content.Context;
import jp.co.cyberagent.android.gpuimage.GPUImageColorBalanceFilter;

/**
 * 
 */
public class ColorBalanceFilterTransformation extends GPUFilterTransformation {

    private float[] mShowdows = {0.0f, 0.0f, 0.0f};
    private float[] mMidtones = {0.0f, 0.0f, 0.0f};
    private float[] mHighlights = {0.0f, 0.0f, 0.0f};
    private boolean mPreserveLuminosity = true;

  public ColorBalanceFilterTransformation(Context context) {
    this(context, new float[]{0.0f, 0.0f, 0.0f}, new float[]{0.0f, 0.0f, 0.0f}, new float[]{0.0f, 0.0f, 0.0f}, true);
  }

  public ColorBalanceFilterTransformation(Context context, float[] showdows, float[] midtones, float[] highlights, boolean preserveLuminosity) {
    super(context, new GPUImageColorBalanceFilter());
    mShowdows = showdows;
	mMidtones = midtones;
	mHighlights = highlights;
	mPreserveLuminosity = preserveLuminosity;
    GPUImageColorBalanceFilter filter = getFilter();
    filter.setShowdows(showdows);
	filter.setMidtones(midtones);
	filter.setHighlights(highlights);
	filter.setPreserveLuminosity(preserveLuminosity);
  }

  @Override public String key() {
    return "ColorBalanceFilterTransformation=" + mShowdows + ")";
  }
}
