package jp.wasabeef.picasso.transformations.gpu;

/**
 * Copyright (C) 2015 Wasabeef
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

import android.content.Context;
import android.graphics.PointF;
import jp.co.cyberagent.android.gpuimage.GPUImageColorMatrixFilter;

/**
 * 
 * 
 * 
 */
public class ColorMatrixFilterTransformation extends GPUFilterTransformation {

    private float mIntensity;
    private float[] mColorMatrix;

  public ColorMatrixFilterTransformation(Context context) {
    this(context, 1.0f, new float[] {
                1.0f, 0.0f, 0.0f, 0.0f,
                0.0f, 1.0f, 0.0f, 0.0f,
                0.0f, 0.0f, 1.0f, 0.0f,
                0.0f, 0.0f, 0.0f, 1.0f
        });
  }

  public ColorMatrixFilterTransformation(Context context, float intensity, float[] colormatrix) {
    super(context, new GPUImageColorMatrixFilter());
    mIntensity = intensity;
	mColorMatrix = colormatrix;
    GPUImageColorMatrixFilter filter = getFilter();
    filter.setIntensity(mIntensity);
	filter.setColorMatrix(mColorMatrix);
  }

  @Override public String key() {
    return "ColorMatrixFilterTransformation(mIntensity = " + mIntensity + ")";
    //    ",lineWidth = " + mLineWidth + ")";
  }
}
