package jp.wasabeef.picasso.transformations.gpu;

/**
 * Copyright (C) 2015 Wasabeef
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

import android.content.Context;
import android.graphics.PointF;
import jp.co.cyberagent.android.gpuimage.GPUImageThresholdEdgeDetection;

/**
 * 
 * 
 * 
 */
public class ThresholdEdgeDetectionFilterTransformation extends GPUFilterTransformation {

	private float mLineSize = 1.0f;
	private float mThreshold = 1.0f;

   //public SobelEdgeDetectionFilterTransformation(Context context) {
   //  this(context);
   //}

  public ThresholdEdgeDetectionFilterTransformation(Context context, float lineSize, float threshold) {
    super(context, new GPUImageThresholdEdgeDetection());
    mLineSize = lineSize;
	mThreshold = threshold;
    GPUImageThresholdEdgeDetection filter = getFilter();
    filter.setLineSize(mLineSize);
	filter.setThreshold(mThreshold);
  }

  @Override public String key() {
    return "SobelEdgeDetectionFilterTransformation = " + mLineSize + 
        ",mThreshold = " + mThreshold + ")";
  }
}
